<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" creationComplete="creationCompleteHandler(event)" title="Pesquisa de Pedido de Compra/Venda da Grade" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="PedidoCompraVendaGradeSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.PedidoCompraVendaGrade;

			import br.com.desenv.nepalign.vo.PedidoCompraVenda;
			import br.com.desenv.nepalign.vo.Grade;
			
			[Bindable]
			public var listaPedidoCompraVendaGrade: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			
			[Bindable]
			private var listaPedidoCompraVendaPesquisa: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaGradePesquisa: ArrayCollection = new ArrayCollection();

			private var pedidoCompraVenda: PedidoCompraVenda;
			
			private var pedidoCompraVendaGradeComponenteDetalhe: PedidoCompraVendaGradeComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): PedidoCompraVendaGrade
			{
				var pedidoCompraVendaGradeFiltro: PedidoCompraVendaGrade = new PedidoCompraVendaGrade();
				
				pedidoCompraVendaGradeFiltro.pedidoCompraVenda = this.pedidoCompraVenda;				
				pedidoCompraVendaGradeFiltro.grade = ignComboBoxAutoCompleteGradePesquisa.selectedItem; 
				return pedidoCompraVendaGradeFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	
				
				var remoteObjectGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("gradeService", listarGradePesquisaResultHandler);	
				remoteObjectGrade.getOperation("listar").send();
				
				var pedidoCompraVendaGradeFiltro: PedidoCompraVendaGrade = new PedidoCompraVendaGrade();
				remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, pedidoCompraVendaGradeFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaPedidoCompraVendaGrade: Page = event.result as Page;
				pageNumber = paginaPedidoCompraVendaGrade.pageNumber;
				totalRecords = paginaPedidoCompraVendaGrade.totalRecords;
				lastPage = paginaPedidoCompraVendaGrade.lastPage();
				listaPedidoCompraVendaGrade = paginaPedidoCompraVendaGrade.recordList;
				labelPaginaAtual.text = "" + paginaPedidoCompraVendaGrade.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaPedidoCompraVendaGrade.totalRecords;
			}

// CARREGANDO COMBOS			
			private function listarGradePesquisaResultHandler( event: ResultEvent ): void 
			{
				listaGradePesquisa = event.result as ArrayCollection;
				listaGradePesquisa.addItemAt(null, 0);
			}

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonPesquisarPedidoCompraVendaPesquisa_clickHandler(event:MouseEvent):void
			{
				var pedidoCompraVendaComponentePesquisa: PedidoCompraVendaComponentePesquisa = new PedidoCompraVendaComponentePesquisa();
				pedidoCompraVendaComponentePesquisa.addEventListener("PedidoCompraVendaSelecionadoEvent", atualizarPedidoCompraVendaPesquisaPorSelecaoResultHandler);
				UPCPopUpManager.instance.addPopUp(pedidoCompraVendaComponentePesquisa, this, true);
				UPCPopUpManager.instance.centerWindow(pedidoCompraVendaComponentePesquisa);
			}
			
			private function atualizarPedidoCompraVendaPesquisaPorSelecaoResultHandler(e:ResultEvent):void
			{
				var novoPedidoCompraVenda: PedidoCompraVenda = e.result as PedidoCompraVenda;
				ignTextInputPedidoCompraVendaPesquisa.text = novoPedidoCompraVenda.id + " - " + novoPedidoCompraVenda.numeroPedido;
				this.pedidoCompraVenda = novoPedidoCompraVenda;
			}
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	
					remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var pedidoCompraVendaGradeComponenteCadastro: PedidoCompraVendaGradeComponenteCadastro = new PedidoCompraVendaGradeComponenteCadastro();
				pedidoCompraVendaGradeComponenteCadastro.pedidoCompraVendaGrade = new PedidoCompraVendaGrade(); 
				pedidoCompraVendaGradeComponenteCadastro.addEventListener("PedidoCompraVendaGradeIncluidoEvent", atualizarListaPedidoCompraVendaGradePorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(pedidoCompraVendaGradeComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(pedidoCompraVendaGradeComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var pedidoCompraVendaGradeSelecionado: PedidoCompraVendaGrade = datagridListaPedidoCompraVendaGrade.selectedItem as PedidoCompraVendaGrade;
				this.dispatchEvent(new ResultEvent("PedidoCompraVendaGradeSelecionadoEvent",false, true, pedidoCompraVendaGradeSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaPedidoCompraVendaGrade_doubleClickHandler(event:MouseEvent):void
			{
				pedidoCompraVendaGradeComponenteDetalhe = new PedidoCompraVendaGradeComponenteDetalhe();
				pedidoCompraVendaGradeComponenteDetalhe.pedidoCompraVendaGrade = datagridListaPedidoCompraVendaGrade.selectedItem as PedidoCompraVendaGrade;
				pedidoCompraVendaGradeComponenteDetalhe.addEventListener("PedidoCompraVendaGradeExcluidoEvent", atualizarListaPedidoCompraVendaGradePorExclusaoResultHandler);
				pedidoCompraVendaGradeComponenteDetalhe.addEventListener("PedidoCompraVendaGradeAtualizadoEvent", atualizarListaPedidoCompraVendaGradePorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(pedidoCompraVendaGradeComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(pedidoCompraVendaGradeComponenteDetalhe);
			}
			
			
			private function atualizarListaPedidoCompraVendaGradePorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	
				remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaPedidoCompraVendaGradePorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	
				remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaPedidoCompraVendaGradePorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	
				remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	
				remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectPedidoCompraVendaGrade: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("pedidoCompraVendaGradeService", listarResultHandler);	
				remoteObjectPedidoCompraVendaGrade.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Pedido de Compra/Venda:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoPedidoCompraVendaPesquisa" styleName="labelValidacao" text="{ignTextInputPedidoCompraVendaPesquisa.errorString}"/>
					<s:HGroup>
						<visual:IgnTextInput id="ignTextInputPedidoCompraVendaPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonPesquisarPedidoCompraVendaPesquisa" width="30" label="..." click="buttonPesquisarPedidoCompraVendaPesquisa_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Grade:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoGradePesquisa" styleName="labelValidacao" text="{ignComboBoxAutoCompleteGradePesquisa.errorString}"/>
					<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteGradePesquisa" dataProvider="{listaGradePesquisa}" labelField="descricao" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>		



		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaPedidoCompraVendaGrade"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaPedidoCompraVendaGrade}" doubleClick="datagridListaPedidoCompraVendaGrade_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="pedidoCompraVenda.numeroPedido" headerText="Pedido de Compra/Venda" resizable="true"/>
						<mx:DataGridColumn dataField="grade.descricao" headerText="Grade" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
